#include <ctype.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/poll.h>

#define HEX(v) ((v) > 9 ? (v) + 'a' - 0xa : (v) + '0' - 0x0)

int main(void)
{
    int i, ret;
    unsigned char ibuf[4096], obuf[8192];
    struct pollfd pollfd = {0, POLLIN};

    fcntl(0, F_SETFL, fcntl(0, F_GETFL) | O_NONBLOCK);

    while (1) {
        ret = poll(&pollfd, 1, -1);

        if (ret == -1) {
            perror("poll");
            return EXIT_FAILURE;
        } else if (ret == 0) {
            continue;
        } else {
            /* Fall through. */
        }

        ret = read(0, ibuf, 4096);

        if (ret == -1) {
            perror("read");
            return EXIT_FAILURE;
        } else if (ret == 0) {
            return EXIT_SUCCESS;
        } else {
            /* Fall through. */
        }

        for (i = 0; i < ret; ++i) {
            obuf[i * 2 + 0] = HEX(ibuf[i] / 16);
            obuf[i * 2 + 1] = HEX(ibuf[i] % 16);
        }

        ret = write(1, obuf, i * 2);

        if (ret == -1) {
            perror("write");
            return EXIT_FAILURE;
        } else if (ret < i * 2) {
            fprintf(stderr, "Failed to flush output buffer. :^(\n");
            return EXIT_FAILURE;
        } else {
            /* Fall through to loop again. */
        }
    }

    return EXIT_SUCCESS;
}

/* vim: set ts=4 sts=4 sw=4 tw=80 et: */
