/* ss-core/core.h
 *
 * Logic!
 *
 * Copyright (C) 2003, 2004
 * Andy Goth     <unununium@openverse.com>
 *
 * This code is available under the GNU General Public License; see COPYING. */

#ifndef SEEN_SSCORE_CORE_H
#define SEEN_SSCORE_CORE_H

#include <sqlite.h>
#include <stdint.h>

#include "evlist/evlist.h"

typedef struct core {
    device_t* sshw, *ssgui;
    evlist_t* evlist;

    unsigned display_id;

    /* All state goes here. */

    sqlite* db;

    int pressure[4];
    int door    [2];
} core_t;

extern int core_init    (core_t* core, device_t* sshw, device_t* ssgui,
                         evlist_t* evlist);
extern int core_cleanup (core_t* core);
extern int core_start   (core_t* core);
extern int core_doors   (core_t* core, int a, int b);
extern int core_pressure(core_t* core, int a, int b, int c, int d);
extern int core_tag_add (core_t* core, uint64_t uid, uint32_t type);
extern int core_tag_del (core_t* core, uint64_t uid);

#endif

/* vim: set ts=4 sts=4 sw=4 tw=80 et: */
